Index: /devel/testlink/automation2.0/.classpath
===================================================================
--- /devel/testlink/automation2.0/.classpath	(revision 3663)
+++ /devel/testlink/automation2.0/.classpath	(revision 4344)
@@ -1,8 +1,8 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <classpath>
+	<classpathentry kind="src" output="target/test-classes" path="src/test/java"/>
+	<classpathentry including="**" kind="src" output="target/test-classes" path="src/test/resources"/>
 	<classpathentry kind="src" output="target/classes" path="src/main/java"/>
 	<classpathentry excluding="**" kind="src" output="target/classes" path="src/main/resources"/>
-	<classpathentry kind="src" output="target/test-classes" path="src/test/java"/>
-	<classpathentry excluding="**" kind="src" output="target/test-classes" path="src/test/resources"/>
 	<classpathentry kind="con" path="org.maven.ide.eclipse.MAVEN2_CLASSPATH_CONTAINER"/>
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.6"/>
Index: /devel/testlink/automation2.0/src/test/java/org/expressolivre/cte/pages/email/MailPage.java
===================================================================
--- /devel/testlink/automation2.0/src/test/java/org/expressolivre/cte/pages/email/MailPage.java	(revision 3853)
+++ /devel/testlink/automation2.0/src/test/java/org/expressolivre/cte/pages/email/MailPage.java	(revision 4344)
@@ -19,67 +19,89 @@
 public class MailPage extends Page {
 
+	/** Botao para criar novo email. */
 	@FindBy(xpath = "//table[@id='folders_tbl']/tbody/tr[1]/td/table/tbody/tr[2]/td/div/span")
 	private WebElement newEmail;
 
+	/** Campo "Para:". */
 	@FindBy(id = "to_1")
 	private WebElement to;
 
+	/** Campo "Assunto:". */
 	@FindBy(id = "subject_1")
 	private WebElement subject;
 
+	/** Botao para enviar email. */
 	@FindBy(id = "send_button_1")
 	private WebElement send;
 
+	/** Flag de importante no momento de compor um email. */
 	@FindBy(id = "important_message_1")
-	/** Flag de importante no momento de compor um email. */
 	private WebElement important;
 
+	/** Flag de importante de um email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[1]/td[2]/span[3]")
-	/** Flag de importante de um email aberto. */
 	private WebElement importantFlag;
 
+	/** Filtra emails importantes. */
 	@FindBy(id = "span_flag_FLAGGED")
-	/** Filtra emails importantes. */
 	private WebElement importantFilter;
 
+	/** Flag normal de um email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[1]/td[2]/span[3]")
 	private WebElement normalFlag;
 
+	/** Flag nao lido de um email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[1]/td[2]/span[2]")
 	private WebElement notReadFlag;
 
+	/** Checkbox de confirmacao de leitura. */
 	@FindBy(id = "return_receipt_1")
 	private WebElement returnReceipt;
 
+	/** Link para acionar exibicao do campo copia oculta Cco. */
 	@FindBy(id = "a_cco_link_1")
 	private WebElement blindCarbonCopyLink;
 
+	/** Campo copia oculta "Cco:". */
 	@FindBy(id = "cco_1")
 	private WebElement blindCarbonCopy;
 
+	/** Link para acionar exibicao do campo copia Cc. */
 	@FindBy(id = "a_cc_link_1")
 	private WebElement carbonCopyLink;
 
+	/** Campo copia "Cc:". */
 	@FindBy(id = "cc_1")
 	private WebElement carbonCopy;
 
+	/** Link para salvar email. */
 	@FindBy(id = "save_message_options_1")
 	private WebElement saveEmail;
 
+	/** Link para adicionar anexos ao email. */
 	@FindBy(linkText = "Anexos: adicionar+")
 	private WebElement attachmentLink;
 
+	/** Link para adicionar 1o anexo. */
 	@FindBy(id = "inputFile_1_1")
 	private WebElement attachment;
 
+	/** Link para adicionar 2o anexo. */
 	@FindBy(id = "inputFile_1_2")
 	private WebElement attachment2;
 
+	/** Link para remover anexo. */
+	@FindBy(id = "linkFile_1_1")
+	private WebElement removeAttachmentLink;
+
+	/** Link para apagar email quando este estiver aberto. */
 	@FindBy(xpath = "//div[@id='footer_menu']/table[@id='footer_box']/tbody/tr[@id='table_message']/td[@id='span_options']/span[1]/span")
 	private WebElement deleteEmailLink;
 
+	/** Link para pasta lixeira. */
 	@FindBy(id = "lINBOX/Trashtree_folders")
 	private WebElement trashFolder;
 
+	/** Link para limpar lixeira. */
 	@FindBy(id = "empty_trash")
 	private WebElement emptyTrashLink;
@@ -88,4 +110,5 @@
 	private WebElement emailsListDiv;
 
+	/** Campo contendo total de emails de uma pasta. */
 	@FindBy(id = "tot_m")
 	private WebElement totalEmails;
@@ -94,7 +117,9 @@
 	private WebElement emailTab;
 
+	/** Checkbox para selecao de todos emails de uma pasta. */
 	@FindBy(id = "chk_box_select_all_messages")
 	private WebElement selectAllEmails;
 
+	/** Link para acionar o menu Ferramentas. */
 	@FindBy(xpath = "//td[@id='link_tools']/div/span")
 	private WebElement toolsMenu;
@@ -116,19 +141,25 @@
 	private WebElement moveEmailButton;
 
+	/** Link para encaminhar em email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[1]/td[3]/span[3]")
 	private WebElement forwardEmail;
 
+	/** Link para responder em email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[1]/td[3]/span[5]")
 	private WebElement replyEmail;
 
+	/** Link para responder a todos em email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[2]/td/div/span[1]")
 	private WebElement replyAllEmail;
 
+	/** Link para responder sem historico em email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[2]/td/div/span[2]")
 	private WebElement replyEmailWithoutHistory;
 
+	/** Link para responder a todos sem historico em email aberto. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr[2]/td/div/span[3]")
 	private WebElement replyAllEmailWithoutHistory;
 
+	/** Link para editar email na pasta de rascunhos. */
 	@FindBy(xpath = "//div[@id='exmail_main_body']/div[2]/table/tbody/tr[1]/td/table/tbody/tr/td[2]/span[2]/span[1]")
 	private WebElement editEmail;
@@ -140,7 +171,16 @@
 	private WebElement discardNewEmail;
 
+	/**
+	 * Esse botao eh no alerta ao fechar uma mensagem nao salva e nao o botao
+	 * salvar para rascunhos.
+	 */
 	@FindBy(xpath = "//div[@id='lertContainer']/div[@id='lertWindow']/div[@id='lertButtons']/a[3]")
-	/** Esse botao eh no alerta ao fechar uma mensagem nao salva e nao o botao salvar para rascunhos. */
 	private WebElement saveNewEmail;
+
+	/** Nome da pasta "Caixa de Entrada". */
+	public static final String INBOX_FOLDER = "lINBOXtree_folders";
+
+	/** Nome da pasta "Enviados". */
+	public static final String SENT_FOLDER = "lINBOX/Senttree_folders";
 
 	/**
@@ -151,4 +191,7 @@
 	}
 
+	/**
+	 * Cria um novo email.
+	 */
 	public void createNewEmail() {
 		this.newEmail.click();
@@ -156,23 +199,46 @@
 	}
 
+	/**
+	 * Cancela criacao de novo email.
+	 */
 	public void cancelNewEmail() {
 		this.cancelNewEmail.click();
 	}
 
+	/**
+	 * Descarta criacao de novo email.
+	 */
 	public void discardNewEmail() {
 		this.discardNewEmail.click();
 	}
 
+	/**
+	 * Salva email na pasta rascunhos.
+	 */
 	public void saveNewEmail() {
 		this.saveNewEmail.click();
 	}
 
+	/**
+	 * Preenche campo assunto.
+	 * 
+	 * @param subject
+	 *            Assunto a ser preenchido.
+	 */
 	public void setSubject(String subject) {
 		this.subject.sendKeys(subject != null ? subject : "");
 	}
 
+	/**
+	 * Preenche corpo (texto) do email.
+	 * 
+	 * @param body
+	 *            Texto a ser preenchido.
+	 */
 	public void setBody(String body) {
 		// Foi o unico jeito que consegui pegar o richtexteditor...
 		if (body != null) {
+			// Troca CR&|LF por <br>
+			body = body.replaceAll("(\r\n|\r|\n|\n\r)", "<br>");
 			((JavascriptExecutor) driver)
 					.executeScript("document.getElementById('body_1').contentWindow.document.body.innerHTML='"
@@ -195,5 +261,5 @@
 	public String readEmail(String subject) {
 		// waitForElementByXpath("//div[@id='exmail_main_body']/table[1]/tbody[@id='border_tbody']/tr[1]/td[2]/table/tbody/tr/td[1]");
-		String id = findEmailIdBySuject(subject);
+		String id = findEmailIdBySubject(subject);
 		id = id.substring(id.lastIndexOf("_") + 1);
 		clickElement(By.id("td_who_" + id));
@@ -302,5 +368,10 @@
 	public void openFolder(String folder) {
 		clickElement(By.id(folder));
+		// Espera pelo "Carregando..." aparecer.
+		waitForElement(By.id("divProgressBar"));
 		waitForElement(By.id("divScrollMain_0"));
+		// Espera pelo "Carregando..." desaparecer.
+		isNotDisplayed(this
+				.waitFindElement(By.id("divProgressBar"), 5000, 1000));
 		waitForElement(By
 				.xpath("//div[@id='divScrollMain_0']/table[@id='table_box']/tbody[@id='tbody_box']/tr[1]/td[1]/input[1]"));
@@ -318,4 +389,7 @@
 	}
 
+	/**
+	 * Filtra somente as mensagens importantes.
+	 */
 	public void setImportantFilter() {
 		this.importantFilter.click();
@@ -337,4 +411,10 @@
 	}
 
+	/**
+	 * Move email para um pasta no servidor.
+	 * 
+	 * @param folderName
+	 *            Nome da pasta pre-existente no servidor.
+	 */
 	public void moveEmail(String folderName) {
 		this.moveEmailLink.click();
@@ -343,4 +423,7 @@
 	}
 
+	/**
+	 * Edita nome de pasta.
+	 */
 	public void editFolder() {
 		this.toolsMenu.click();
@@ -350,4 +433,10 @@
 	}
 
+	/**
+	 * Cria nova pasta.
+	 * 
+	 * @param folderName
+	 *            Nome da pasta a ser criada.
+	 */
 	public void createNewFolder(String folderName) {
 		this.editFolder();
@@ -359,4 +448,10 @@
 	}
 
+	/**
+	 * Exclui pasta.
+	 * 
+	 * @param folderName
+	 *            Nome da pasta a ser excluida.
+	 */
 	public void deleteFolder(String folderName) {
 		this.editFolder();
@@ -377,4 +472,7 @@
 	}
 
+	/**
+	 * Marca email como importante apos ler.
+	 */
 	public void setImportantFlag() {
 		this.waitForElement(By
@@ -383,4 +481,7 @@
 	}
 
+	/**
+	 * Marca email como normal apos ler.
+	 */
 	public void setNormalFlag() {
 		this.waitForElement(By
@@ -389,4 +490,7 @@
 	}
 
+	/**
+	 * Marca email como nao lido apos ler.
+	 */
 	public void setNotReadFlag() {
 		this.waitForElement(By
@@ -419,4 +523,7 @@
 	}
 
+	/**
+	 * Seleciona todos emails da pasta corrente.
+	 */
 	public void selectAllEmails() {
 		this.selectAllEmails.click();
@@ -456,4 +563,11 @@
 	}
 
+	/**
+	 * Remove anexo do email sendo composto.
+	 */
+	public void removeAttachment() {
+		this.removeAttachmentLink.click();
+	}
+
 	public void addAttachment2(String attachment) {
 		this.attachmentLink.click();
@@ -476,7 +590,7 @@
 
 	/**
-	 * @param checkAlert
-	 */
-	public void closeMail(boolean checkAlert) {
+	 * @param discardEmail
+	 */
+	public void closeMail(boolean discardEmail) {
 
 		// Na versao Serpro:
@@ -489,14 +603,31 @@
 		super.clickElement(By.xpath("//td[@id='border_id_1']//img"));
 
-		if (checkAlert) {
-			Alert closeAlert = driver.switchTo().alert();
-			closeAlert.accept();
+		// if (checkAlert) {
+		// Alert closeAlert = driver.switchTo().alert();
+		// closeAlert.accept();
+		// }
+
+		// Clica em descartar.
+		if (discardEmail) {
+			super.clickElement(By
+					.xpath("//div[@id='lertWindow']/div[@id='lertButtons']/a[2]"));
 		}
 	}
 
-	public void closeMail(String id) {
+	public void closeMail(String id, boolean discardEmail) {
 		super.clickElement(By.xpath("//td[@id='border_id_" + id + "']//img"));
-	}
-
+		// Clica em cancelar
+		if (discardEmail) {
+			super.clickElement(By
+					.xpath("//div[@id='lertWindow']/div[@id='lertButtons']/a[2]"));
+		}
+	}
+
+	/**
+	 * Envia email.
+	 * 
+	 * @param id
+	 *            Id do email a ser enviado.
+	 */
 	public void sendMail(String id) {
 		super.findAndClickElement("send_button_" + id);
@@ -525,18 +656,30 @@
 	 * @param select
 	 *            Se email encontrado, deseja seleciona-lo?
-	 * @return "id" do email.
+	 * @return "id" do email se encontrar, <code>null</code> se nao encontrar.
 	 */
 	public String findEmailIdBySuject(String subject, boolean select) {
+		System.out.println("searching for --------->" + subject);
 		String html = driver.getPageSource();
-		String part1 = StringUtils.substringBefore(html, subject);
-		int start = StringUtils.lastIndexOf(part1, "id=\"") + 4;
-		int last = StringUtils.indexOf(part1, "\"", start);
-		String id = StringUtils.substring(part1, start, last);
-
-		if (select) {
-			// Marca checkbox correspondente ao id da mensagem.
-			clickElement(By.id("check_box" + id.substring(1)));
+		// System.out.println(html.indexOf(subject));
+		// System.out.println(html);
+		if (html.indexOf(subject) >= 0) {
+			String part1 = StringUtils.substringBefore(html, subject);
+			int start = StringUtils.lastIndexOf(part1, "id=\"") + 4;
+			int last = StringUtils.indexOf(part1, "\"", start);
+			String id = StringUtils.substring(part1, start, last);
+			System.out.println("******************");
+			System.out.println("******************");
+			System.out.println("******************");
+			System.out.println("******************");
+			System.out.println("******************");
+			System.out.println("******************");
+			System.out.println(id);
+			if (select) {
+				// Marca checkbox correspondente ao id da mensagem.
+				clickElement(By.id("check_box" + id.substring(1)));
+			}
+			return id;
 		}
-		return id;
+		return null;
 	}
 
@@ -570,5 +713,26 @@
 	}
 
-	public String findEmailIdBySuject(String subject) {
+	/**
+	 * Procura email baseado no assunto na pasta corrente.
+	 * 
+	 * @param subject
+	 *            Assunto a ser pesquisado.
+	 * @return Id do email encontrado.
+	 */
+	public String findEmailIdBySubject(String subject) {
+		return findEmailIdBySuject(subject, false);
+	}
+
+	/**
+	 * Procura email baseado no assunto em uma pasta especifica.
+	 * 
+	 * @param folder
+	 *            Pasta de pesquisa.
+	 * @param subject
+	 *            Assunto a ser pesquisado.
+	 * @return Id do email encontrado.
+	 */
+	public String findEmailIdBySubject(String folder, String subject) {
+		this.openFolder(folder);
 		return findEmailIdBySuject(subject, false);
 	}
@@ -619,4 +783,9 @@
 	}
 
+	/**
+	 * @param id
+	 *            Id do email.
+	 * @return Texto do email.
+	 */
 	public Object getBody(String id) {
 		waitForElement(By.id("body_" + id));
